/*
 * @Author: 海弟君
 * @Date: 2022-07-02 14:14:36
 * @LastEditTime: 2022-07-19 23:09:07
 * @Description: file content
 * @Contact: QQ：1532332928
 */
// bootstrap-table表格配置
if (typeof $.fn.bootstrapTable !== "undefined") {
    $.fn.bootstrapTable.custom = {
        method: 'post',
        contentType: "application/x-www-form-urlencoded", //必须要有！！！！
        // 排序相关
        sortable: true, // 是否启用排序
        // 分页相关
        pagination: true, //是否显示分页（*）
        contentType: 'application/x-www-form-urlencoded',
        sidePagination: "server", //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1, //初始化加载第一页，默认第一页,并记录
        pageSize: 15, //每页的记录行数（*）
        pageList: [15, 25, 50, 100], //可供选择的每页的行数（*）
        // 显示相关
        search: false, // 是否显示表格搜索
        searchHighlight: true, // 搜索内容高亮
        searchAlign: 'left', // 搜索框显示位置
        strictSearch: false, // 设置为 true启用全匹配搜索，否则为模糊搜索。
        showPrint: false, // 是否显示打印按钮
        showRefresh: true, // 是否显示刷新按钮
        showColumns: true, // 是否显示所有的列（选择显示的列）
        minimumCountColumns: 2, // 最少允许的列数
        // toolbar: '#toolbar', //工具按钮用哪个容器
        buttonsClass: 'btn btn-outline-light', // 工具按钮样式
        queryParams: 'queryParams', // 自定义搜索
        responseHandler: function(res) {
            return {
                'total': res.total > 0 ? res.total : 0, //总的数据长度
                'rows': res.list.length > 0 ? res.list : [] //单页查询返回的数据
            }
        },
        loadingFontSize: '18px' // 加载提示字体大小
    };
    $.extend($.fn.bootstrapTable.defaults, $.fn.bootstrapTable.custom);
}
// bootstrap-table 自定义更多搜索
function queryParams(params) {
    var fdp = {}
    fdp.limit = params.limit;
    fdp.offset = params.offset;
    $('#moreSearch').find(':input[name]').each(function() {
        fdp[$(this).attr('name')] = $(this).val()
    })
    return fdp
}
// 网站列表相关操作方法
function vhostNane(name) {
    return '<a href="?c=vhost&a=impLogin&name=' + name + '"  target="_blank">' + name + '</a>';
}
$(".bootstrap-table-only").on('check.bs.table uncheck.bs.table ' + 'check-all.bs.table uncheck-all.bs.table',
    function() {
        $("#multi-select").find('button').prop('disabled', !$(".bootstrap-table-only").bootstrapTable('getSelections').length)
    }
);

function moduleName(value){
    return value == '' ? '无(旧格式)' : value;
}

function vhostStatus(value, row, index) {
    var html = [];
    var data = [{ name: '正常' }, { name: '暂停' }, { name: '超流量' }, { name: '超数据库' }];
    html.push('<select class="form-control w-110px" id="v-' + row.uid + '" onChange="javascript:setStatus(\'' + row.name + '\',this.value)">');
    for (let index = 0; index < 4; index++) {
        html.push('<option value="' + index + '" ' + (value == index ? 'selected' : '') + '>' + data[index].name + '</option>');
    }
    html.push('</select>');
    return html.join('');
}

function vhostOperation(value, row, index) {
    var html = [];
    html.push('<a href="?c=product&a=sellForm&name=' + row.name + '&product=vhost&edit=1" class="btn btn-sm btn-primary">修改</a>');
    html.push('<a href="javascript:changePw(\'' + row.name + '\')" class="btn btn-sm btn-warning">密码</a>');
    html.push('<a href="javascript:addMonth(\'' + row.name + '\')" class="btn btn-sm btn-light">延时</a>');
    return html.join('&nbsp;');
}

function vhostCheckbox(value, row, index) {
    return '<label><input data-index="' + index + '" name="btSelectItem" type="checkbox" value="' + row.name + '"><span></span></label>';
}

function ajaxSync(name) {
    //$("#sync").css('display', '');
    var dlog = art.dialog({ id: 'id22', icon: 'face-smile', left: '50%', top: '20%' });
    dlog.content("请等待,正在执行中...<br>如果该空间数据量大，则有可能会超过php执行时间而失败");
    $.ajax({
        type: 'get',
        url: '?c=vhost&a=resync',
        data: 'name=' + name,
        dataType: 'json',
        success: function(ret) {
            var msg = ret['code'] == 200 ? "重建成功" : ret['msg'] ? ret['msg'] : "重建失败";
            dlog.content(msg);
            dlog.title("三秒后关闭");
            dlog.time(3);
        }
    });
}

function change_checked_status(status) {
    if (confirm("确定要对所有选中的主机进行操作吗?") === false) {
        return;
    }
    //init_div();
    var status_name = status == 1 ? "暂停 " : '开通 ';
    var dlog = art.dialog({ id: 'id22', icon: 'face-smile', left: '50%', top: '20%' });
    dlog.content('');
    $(".bootstrap-table-only > tbody").find(":checkbox:checked").each(
        function() {
            var name = this.value;
            if (!name) {
                return;
            }
            $.ajax({
                type: 'get',
                url: '?c=vhost&a=setStatus',
                data: 'name=' + name + '&status=' + status,
                dataType: 'json',
                async: false,
                success: function(ret) {
                    var msg;
                    if (ret['code'] != 200) {
                        msg = '<font color="#fff">';
                        msg += ret['msg'] ? ret['msg'] :
                            status_name + name + ' 失败';
                        msg += "</font>";
                    } else {
                        msg = status_name + name + ' 成功';
                    }
                    document.getElementById('show_msg').style.height = count * 20;
                    $("#aui_content").append(msg + '<br>');
                    count++;
                }
            });
        });
    //setTimeout(close_showmsg, 2000);
    setTimeout(function() {
        dlog.close();
        window.location = window.location;
        dlog = null;
    }, 3000);
}

function del_checked() {
    if (confirm("确定要删除所有选中的主机吗?") === false) {
        return;
    }
    //init_div();
    var dlog = art.dialog({ id: 'id22', icon: 'face-smile', left: '50%', top: '20%' });
    dlog.content('');
    $(".bootstrap-table-only > tbody").find(":checkbox:checked")
        .each(
            function() {
                var name = this.value;
                if (!name) {
                    return;
                }
                $.ajax({
                    type: 'get',
                    url: '?c=vhost&a=del',
                    data: 'name=' + name,
                    dataType: 'json',
                    async: false,
                    success: function(ret) {
                        var msg;
                        if (ret['code'] == 200) {
                            msg = '删除 ' + name + ' 成功';
                        } else {
                            msg = '删除 ' + name + ' 失败';
                        }
                        $("#aui_content").append(msg + '<br>');
                        count++;
                    }
                });
            });
    setTimeout(function() {
        dlog.close();
        window.location = window.location;
        dlog = null;
    }, 3000);
}

function show_piao_div() {
    var div = document.getElementById('show_msg');
    if (!div) {
        return;
    }
    if (div.style.display != 'none') {
        return;
    }
    div.style.height = 30;
    div.style.top = 260;
    div.style.right = 15;
    div.style.width = 200;
    div.style.display = 'block';
    // setTimeout(close_showmsg,1000);
}

function close_showmsg() {
    $("#show_msg").fadeOut(2000);
}

function init_div() {

    var div = document.getElementById('show_msg');
    if (!div) {
        return;
    }
    div.style.height = 0;
    div.style.width = 0;
    div.innterHTML = '';
    div.style.display = 'none';
}

function changePw(name) {
    var r = confirm("确定要重设密码吗?");
    if (r == false)
        return;
    $.get("?c=vhost&a=randPassword&name=" + name, function(data) {
        Swal.fire('重设结果', data);
        // $("#result").html(data);
    });
}

function setStatus(name, status) {
    $.ajax({
        type: 'get',
        url: '?c=vhost&a=setStatus',
        data: 'name=' + name + '&status=' + status,
        dataType: 'json',
        success: function(ret) {
            if (ret['code'] != 200) {
                return alert(ret['msg'] ? ret['msg'] : '操作失败');
            }
            $(".bootstrap-table-only").bootstrapTable('refresh');
            // window.location.reload();
        }
    });
}

function addMonth(name) {
    var r = prompt("需要延时多少个月?", '1');
    if (r == null) {
        return;
    }
    var dlog = art.dialog({ id: 'id22', icon: 'face-smile', left: '50%', top: '20%', show: false });
    $.get("?c=product&a=addExpireTime&name=" + name + "&month=" + r, function(
        data) {
        dlog.show(true);
        dlog.content(data);
        setTimeout(function() {
            $(".bootstrap-table-only").bootstrapTable('refresh');
            // window.location = window.location;
        }, 2000);
    });
}

function sync_checked() {
    if (confirm("确定要重建所有选中的主机吗?") === false) {
        return;
    }
    //init_div();
    //$("#sync").css('display', '');
    var dlog = art.dialog({ id: 'id22', content: '请等待,正在执行中...<br>', icon: 'face-smile', left: '50%', top: '20%' });
    //$("#sync").html("请等待,正在执行中......<br>如果该空间数据量大，请在kangle的3311管理中将超时时间调大");
    $(".bootstrap-table-only > tbody").find(":checkbox:checked").each(function() {
        var name = this.value;
        if (!name) {
            return;
        }
        $.ajax({
            type: 'get',
            url: '?c=vhost&a=resync',
            data: 'name=' + name,
            dataType: 'json',
            async: false,
            success: function(ret) {
                var msg;
                if (ret['code'] != 200) {
                    msg = '<font color="#fff">';
                    msg += ret['msg'] ? ret['msg'] : '重建' + name + '失败';
                    msg += "</font>";
                } else {
                    msg = '重建' + name + '成功';
                }
                $("#aui_content").append(msg + '<br>');
                count++;
            }
        });

    });
    setTimeout(function() {
        dlog.close();
        window.location = window.location;
        dlog = null;
    }, 3000);
}

function select_all(checked) {
    if (checked == 1) {
        $(":checkbox").attr('checked', true);
    } else {
        $.each($(":checkbox"), function(key, val) {
            val.checked = !val.checked;
        });
    }
}

function delVhost(name) {
    var r = confirm("如果要关闭空间，更改其状态即可，删除空间后数据不可恢复，确定要删除空间吗?");
    if (r == false) {
        return;
    }
    var dlog = art.dialog({ id: 'id22', content: '请等待,正在执行中...<br>', icon: 'face-smile', left: '50%', top: '20%' });
    $.ajax({
        type: 'post',
        url: "?c=vhost&a=del",
        data: "name=" + name,
        async: false,
        dataType: 'json',
        success: function(ret) {
            if (ret['code'] != 200) {
                dlog.content(ret['msg'] ? ret['msg'] : '删除' + name + '失败');
                return;
            }
            $(".bootstrap-table-only").bootstrapTable('refresh');
            // window.location.reload();
        }
    });
}

// 产品列表修改操作方法

function productOperation(value, row, index){
    var html = [];
    html.push('<a href="?c=vhostproduct&a=editproductForm&id='+row.id+'" class="btn btn-sm btn-primary">修改</a>');
    html.push('<a href="?c=vhostproduct&a=delProduct&id='+row.id+'" class="btn btn-sm btn-danger">删除</a>');
    html.push('<a href="?c=product&a=sellForm&product_id='+row.id+'" class="btn btn-sm btn-light">增加网站</a>');
    return html.join('&nbsp;');
}

function checkNodeStatus(value, row, index){
    return '<div id="tr'+row.name+'"><a href="javascript:check_node(\''+row.name+'\')">查询状态</a></div>';
}

function manynodeOperation(value, row, index){
    var html = [];
    html.push('<a href="?c=manynode&a=addFrom&name='+row.name+'" class="btn btn-sm btn-primary">修改</a>');
    html.push('<a href="javascript:if(confirm(\'确定删除?\')){location=\'?c=manynode&a=del&name='+row.name+'\';}" class="btn btn-sm btn-danger">删除</a>');
    html.push('<a href="#" class="btn btn-sm btn-light synchronize" data-name="'+row.name+'">同步</a>');
    return html.join('&nbsp;');
}