<?php
function formatsize($size)
{ //单位转换
    $danwei = array(' B ', ' K ', ' M ', ' G ', ' T ');
    $allsize = array();
    $i = 0;
    for ($i = 0; $i < 5; $i++) {
        if (floor($size / pow(1024, $i)) == 0) {
            break;
        }
    }
    for ($l = $i - 1; $l >= 0; $l--) {
        $allsize1[$l] = floor($size / pow(1024, $l));
        $allsize[$l] = $allsize1[$l] - $allsize1[$l + 1] * 1024;
    }
    $fsize = [];
    $len = count($allsize);
    for ($j = $len - 1; $j >= 0; $j--) {
        $fsize[$j] = $allsize[$j] . $danwei[$j];
    }
    return $fsize;
}

function sys_linux()
{
    // CPU
    if (false === ($str = @file("/proc/cpuinfo"))) return false;
    $str = implode("", $str);
    @preg_match_all("/model\s+name\s{0,}\:+\s{0,}([\w\s\)\(\@.-]+)([\r\n]+)/s", $str, $model);
    @preg_match_all("/cpu\s+MHz\s{0,}\:+\s{0,}([\d\.]+)[\r\n]+/", $str, $mhz);
    @preg_match_all("/cache\s+size\s{0,}\:+\s{0,}([\d\.]+\s{0,}[A-Z]+[\r\n]+)/", $str, $cache);
    @preg_match_all("/bogomips\s{0,}\:+\s{0,}([\d\.]+)[\r\n]+/", $str, $bogomips);
    if (false !== is_array($model[1])) {
        $res['cpu']['num'] = sizeof($model[1]); // cpu核心数量
        $res['cpu']['info'] = $model[1][0]; // cpu名称
        $res['cpu']['frequency'] = $mhz[1][0]; // cpu频率
        $res['cpu']['secondaryCache'] = $cache[1][0]; // cpu二级缓存
        $rse['cpu']['bogomips'] = $bogomips[1][0];
    }
    // 使用率
    $stat1 = GetCoreInformation();
    sleep(1);
    $stat2 = GetCoreInformation();
    $res['cpu']['usage'] = GetCpuPercentages($stat1, $stat2);
    // 硬盘使用情况
    $res['disk']['total'] = round(@disk_total_space(".") / (1024 * 1024 * 1024), 3); //总
    $res['disk']['available'] = round(@disk_free_space(".") / (1024 * 1024 * 1024), 3); //可用
    $res['disk']['used'] = $res['disk']['total'] - $res['disk']['available']; //已用
    $res['disk']['percent'] = (floatval($res['disk']['total']) != 0) ? round($res['disk']['used'] / $res['disk']['total'] * 100, 2) : 0;
    // 每个网络端口利用率
    $strs = @file("/proc/net/dev");
    $lines = count($strs);
    for ($i = 2; $i < $lines; $i++) {
        preg_match_all("/([^\s]+):[\s]{0,}(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/", $strs[$i], $info);
        $res['network']['OutSpeed'][$i] = $info[10][0];
        $res['network']['InputSpeed'][$i] = $info[2][0];
        $res['network']['NetOut'][$i] = formatsize($info[10][0]);
        $res['network']['NetInput'][$i] = formatsize($info[2][0]);
        $res['network']['NetWorkName'][$i] = $info[1][0];
    }

    if (false === ($str = @file('/proc/uptime'))) {
        return false;
    }

    $str = explode(' ', implode('', $str));
    $str = trim($str[0]);
    $min = $str / 60;
    $hours = $min / 60;
    $days = floor($hours / 24);
    $hours = floor($hours - $days * 24);
    $min = floor($min - $days * 60 * 24 - $hours * 60);

    if ($days !== 0) {
        $res['uptime'] = $days . '天';
    }

    if ($hours !== 0) {
        $res['uptime'] .= $hours . '小时';
    }

    $res['uptime'] .= $min . '分钟';

    if (false === ($str = @file('/proc/meminfo'))) {
        return false;
    }

    $str = implode('', $str);
    preg_match_all('/MemTotal\\s{0,}\\:+\\s{0,}([\\d\\.]+).+?MemFree\\s{0,}\\:+\\s{0,}([\\d\\.]+).+?Cached\\s{0,}\\:+\\s{0,}([\\d\\.]+).+?SwapTotal\\s{0,}\\:+\\s{0,}([\\d\\.]+).+?SwapFree\\s{0,}\\:+\\s{0,}([\\d\\.]+)/s', $str, $buf);
    preg_match_all('/Buffers\\s{0,}\\:+\\s{0,}([\\d\\.]+)/s', $str, $buffers);
    $res['memTotal'] = round($buf[1][0] / 1024, 2);
    $res['memFree'] = round($buf[2][0] / 1024, 2);
    $res['memBuffers'] = round($buffers[1][0] / 1024, 2);
    $res['memCached'] = round($buf[3][0] / 1024, 2);
    $res['memUsed'] = $res['memTotal'] - $res['memFree'];
    $res['memPercent'] = floatval($res['memTotal']) != 0 ? round($res['memUsed'] / $res['memTotal'] * 100, 2) : 0;
    $res['memRealUsed'] = $res['memTotal'] - $res['memFree'] - $res['memCached'] - $res['memBuffers'];
    $res['memRealFree'] = $res['memTotal'] - $res['memRealUsed'];
    $res['memRealPercent'] = floatval($res['memTotal']) != 0 ? round($res['memRealUsed'] / $res['memTotal'] * 100, 2) : 0;
    $res['memCachedPercent'] = floatval($res['memCached']) != 0 ? round($res['memCached'] / $res['memTotal'] * 100, 2) : 0;
    $res['swapTotal'] = round($buf[4][0] / 1024, 2);
    $res['swapFree'] = round($buf[5][0] / 1024, 2);
    $res['swapUsed'] = round($res['swapTotal'] - $res['swapFree'], 2);
    $res['swapPercent'] = floatval($res['swapTotal']) != 0 ? round($res['swapUsed'] / $res['swapTotal'] * 100, 2) : 0;

    if (false === ($str = @file('/proc/loadavg'))) {
        return false;
    }

    $str = explode(' ', implode('', $str));
    $str = array_chunk($str, 4);
    $res['loadAvg'] = implode(' ', $str[0]);
    return $res;
}

function sys_windows()
{
    if (5 <= PHP_VERSION) {
        $objLocator = new COM('WbemScripting.SWbemLocator');
        $wmi = $objLocator->ConnectServer();
        $prop = $wmi->get('Win32_PnPEntity');
    } else {
        return false;
    }

    $sysinfo = GetWMI($wmi, 'Win32_OperatingSystem', array('LastBootUpTime', 'TotalVisibleMemorySize', 'FreePhysicalMemory'));
    $res['uptime'] = $sysinfo[0]['LastBootUpTime'];
    $sys_ticks = 3600 * 8 + time() - strtotime(substr($res['uptime'], 0, 14));
    $min = $sys_ticks / 60;
    $hours = $min / 60;
    $days = floor($hours / 24);
    $hours = floor($hours - $days * 24);
    $min = floor($min - $days * 60 * 24 - $hours * 60);

    if ($days !== 0) {
        $res['uptime'] = $days . '天';
    }

    if ($hours !== 0) {
        $res['uptime'] .= $hours . '小时';
    }

    $res['uptime'] .= $min . '分钟';
    $res['memTotal'] = round($sysinfo[0]['TotalVisibleMemorySize'] / 1024, 2);
    $res['memFree'] = round($sysinfo[0]['FreePhysicalMemory'] / 1024, 2);
    $res['memUsed'] = $res['memTotal'] - $res['memFree'];
    $res['memPercent'] = round($res['memUsed'] / $res['memTotal'] * 100, 2);
    $loadinfo = GetWMI($wmi, 'Win32_Processor', array('LoadPercentage'));
    $res['loadAvg'] = $loadinfo[0]['LoadPercentage'] . '%';
    return $res;
}

function GetCoreInformation()
{
    $data = file('/proc/stat');
    $cores = array();
    foreach ($data as $line) {
        if (preg_match('/^cpu[0-9]/', $line)) {
            $info = explode(' ', $line);
            $cores[] = array('user' => $info[1], 'nice' => $info[2], 'sys' => $info[3], 'idle' => $info[4], 'iowait' => $info[5], 'irq' => $info[6], 'softirq' => $info[7]);
        }
    }
    return $cores;
}
function GetCpuPercentages($stat1, $stat2)
{
    if (count($stat1) !== count($stat2)) {
        return;
    }
    $cpus = array();
    for ($i = 0, $l = count($stat1); $i < $l; $i++) {
        $dif = array();
        $dif['user'] = $stat2[$i]['user'] - $stat1[$i]['user'];
        $dif['nice'] = $stat2[$i]['nice'] - $stat1[$i]['nice'];
        $dif['sys'] = $stat2[$i]['sys'] - $stat1[$i]['sys'];
        $dif['idle'] = $stat2[$i]['idle'] - $stat1[$i]['idle'];
        $dif['iowait'] = $stat2[$i]['iowait'] - $stat1[$i]['iowait'];
        $dif['irq'] = $stat2[$i]['irq'] - $stat1[$i]['irq'];
        $dif['softirq'] = $stat2[$i]['softirq'] - $stat1[$i]['softirq'];
        $total = array_sum($dif);
        $cpu = array();
        foreach ($dif as $x => $y) $cpu[$x] = round($y / $total * 100, 2);
        $cpus['cpu' . $i] = $cpu;
    }
    return $cpus;
}

function GetWMI($wmi, $strClass, $strValue = array())
{
    $arrData = array();
    $objWEBM = $wmi->Get($strClass);
    $arrProp = $objWEBM->Properties_;
    $arrWEBMCol = $objWEBM->Instances_();

    foreach ($arrWEBMCol as $objItem) {
        @reset($arrProp);
        $arrInstance = array();

        foreach ($arrProp as $propItem) {
            eval('$value = $objItem->' . $propItem->Name . ';');

            if (empty($strValue)) {
                $arrInstance[$propItem->Name] = trim($value);
            } else {
                if (in_array($propItem->Name, $strValue)) {
                    $arrInstance[$propItem->Name] = trim($value);
                }
            }
        }

        $arrData[] = $arrInstance;
    }

    return $arrData;
}

function sys_info()
{
    switch (PHP_OS) {
        case 'Linux':
            return sys_linux();
        case 'WINNT':
            return sys_windows();
        default:
            break;
    }

    return $sysInfo;
}
